package Platform;

print "loading BS_unix\n" if( $main::dl );

require Exporter;

@ISA = qw( Exporter );

@EXPORT = qw( bsconnect bsalarm );


$Platform::has_fork = 1;


sub bsalarm {
    my( $time ) = @_;

    return alarm( $time );
}


sub bsconnect {
    my( $socket, $addr ) = @_;
    
    return connect( $socket, $addr );
}


sub bswait {
    wait;
}


sub bswait_nohang {
    require POSIX;
    my $pid = waitpid( -1, &POSIX::WNOHANG );
    return( $pid?$pid:-1 );
}


sub strftime {
    require POSIX;
    return( POSIX::strftime( $_[0], gmtime($_[1]) ) );
}


sub hostname {
    my $hostname;
    eval {
	require Sys::Hostname;
	$hostname = Sys::Hostname::hostname();
    };
    $hostname || ($hostname = $ENV{"HOST"});
    $hostname || chomp( $hostname = `/bin/hostname` );
    $hostname =~ s/\..*//;
    $hostname =~ tr/A-Z/a-z/;
    return( $hostname );
}


sub override_root {
    return undef;
}



sub replace {
    my( $file, $newfile ) = @_;

    return( rename( $file, $newfile ) );
}


sub system {
    my( @args ) = @_;

    return( system( @args ) );
}


sub filepath {
    my( $name ) = @_;

    return $name;
}

1;
