package Monitor::Monitor;

require 5.001;

use strict;

@Monitor::Monitor::ISA = qw(Schedule);

sub new
{
   print STDERR "new Monitor::Monitor object????\n";
}


sub add_check {
}





sub check
{
}


sub late_check
{
}


sub log
{
}


sub run
{
    my( $self, $mode, @args ) = @_;

    $self->{"monitor_mode"} = $mode;
    if( defined $self->{"monitor_reports_$mode"} ) {
	my $id;

	foreach $id (@{$self->{"monitor_reports_$mode"}}) {
	    uxmon::unreport( $id->[0], $id );
	}
	foreach $id (@{$self->{"monitor_variables_$mode"}}) {
	    uxmon::unset_variable( $id->[0], $id->[1] );
	}
    }
    $self->{"monitor_reports_$mode"} = $self->{"monitor_variables_$mode"} = [];
    if( $mode eq "check" ) {
	$self->check(@args);
    }
    else {
	$self->late_check( @args );
    }
}


sub report {
    my( $self, $item, $value, $comment ) = @_;
    my $id;

    push( @{$self->{"monitor_reports_".$self->{"monitor_mode"}}},
	  $id = [ $item, $value ] );
    uxmon::report( $item, $value, $comment, $id );
}



sub set_variable {
    my( $self, $host, $variable, $value ) = @_;

    $host =~ s/ /_/g;
    $variable =~ s/ /_/g;
    unless( $host) { $host = $main::hostname; }
    push( @{$self->{"monitor_variables_".$self->{"monitor_mode"}}},
	  [ $host, $variable ] );
    uxmon::set_variable( $host, $variable, $value );
}


sub execute_on {
    my( $self, $host, $command ) = @_;

    if( $host eq $main::hostname || ! $host ) {
        return $command;
    }
    my $cmd = "$command";
    if( $self->{"rexec_command"} ) {
        $cmd = $self->{"rexec_command"};
    }
    $cmd =~ s/\$host/$host/;
    $cmd =~ s/\$command/$command/;
    return $cmd;
}


sub set_execute_on {
    my( $self, $cmd ) = @_;

    $self->{"rexec_command"} = $cmd;
}
      

sub timeout_execute {
    my( $self, $command, $timeout ) = @_;
    my $pid;
    
    my $text = "";
    if( ! defined $timeout ) { $timeout = 10; }
    eval {
        $SIG{"ALRM"} = sub { die ""; };
	Platform::bsalarm( $timeout );
        $pid = open( _CMD, "$command|" );
	while( <_CMD> ) {
	    $text .= $_;
 	}
	close( _CMD );
	undef $pid;
	Platform::bsalarm(0);
    };
    if( $pid ) {
        kill 15, $pid;
	eval {
	    $SIG{"ALRM"} = sub { kill 9, $pid; die ""; };
	    Platform::bsalarm(1);
	    waitpid $pid, 0;
	}
    }
    $SIG{"ALRM"} = "IGNORE";
    return( $text );
}



1;
