package Monitor::ypbind;

require 5.002;

use strict;

@Monitor::ypbind::ISA = qw(Monitor::Monitor);

# create the objects + memory space needed
sub new
{

    my ($this, $pscomm) = @_;
    my  $class = ref($this) || $this;
    my  $self = {};

    bless($self, $class);

    $self->{"htable"} = [];

    return($self);
}

sub check
{
    my ($self) = @_;
    my( $htable ) = $self->{"htable"};

    my $item = $uxmon::hostname.".ypbind";

    my $ypbind = `/usr/bin/ypwhich 2>&1`;
    my $ret = $?;
    chomp $ypbind;

    # report on what's going on - if we're in debug mode
    if( $main::dl>3 )
    {
        print "ypwhich: retcode='$ret', message='$ypbind'\n";
    }

    if ($ret == 0)
    {
    	$self->report( $item, $main::status_codes{"green"}, "NIS server is: $ypbind" );
    }
    else
    {
        $self->report( $item, $main::status_codes{"red"}, "Error message: $ypbind" );
    }
}

1;
